import { CommonModule } from '@angular/common';
import { HttpClient, HttpHeaders } from '@angular/common/http';
import { NgModule, Optional, SkipSelf, InjectionToken, Injectable, Inject, defineInjectable, inject } from '@angular/core';
import { Subject } from 'rxjs';
import { map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var BASE_URL = new InjectionToken('baseUrl');
var PybLibApiModule = /** @class */ (function () {
    function PybLibApiModule(parentModule) {
        if (parentModule) {
            throw new Error('GreetingModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * @param {?} config
     * @return {?}
     */
    PybLibApiModule.forRoot = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: PybLibApiModule,
            providers: [
                { provide: BASE_URL, useValue: config.baseUrl }
            ]
        };
    };
    PybLibApiModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                },] }
    ];
    /** @nocollapse */
    PybLibApiModule.ctorParameters = function () { return [
        { type: PybLibApiModule, decorators: [{ type: Optional }, { type: SkipSelf }] }
    ]; };
    return PybLibApiModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BalanceService = /** @class */ (function () {
    function BalanceService(http, baseUrl) {
        this.http = http;
        this.baseUrl = baseUrl;
    }
    /**
     * @param {?} supplierKey
     * @return {?}
     */
    BalanceService.prototype.getBalance = /**
     * @param {?} supplierKey
     * @return {?}
     */
    function (supplierKey) {
        return this.http.get(this.baseUrl + "/sup_widget/suppliers/" + supplierKey + "/balance", {});
    };
    BalanceService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    BalanceService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: String, decorators: [{ type: Inject, args: [BASE_URL,] }] }
    ]; };
    /** @nocollapse */ BalanceService.ngInjectableDef = defineInjectable({ factory: function BalanceService_Factory() { return new BalanceService(inject(HttpClient), inject(BASE_URL)); }, token: BalanceService, providedIn: "root" });
    return BalanceService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardTransactionService = /** @class */ (function () {
    function CardTransactionService(http, baseUrl) {
        this.http = http;
        this.baseUrl = baseUrl;
        this.transactions$ = new Subject();
    }
    /**
     * @param {?} supplierKey
     * @param {?=} params
     * @return {?}
     */
    CardTransactionService.prototype.getTransactions = /**
     * @param {?} supplierKey
     * @param {?=} params
     * @return {?}
     */
    function (supplierKey, params) {
        return this.http.post(this.baseUrl + "/sup_widget/suppliers/" + supplierKey + "/pcard/get_general_report_v3", params);
    };
    CardTransactionService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    CardTransactionService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: String, decorators: [{ type: Inject, args: [BASE_URL,] }] }
    ]; };
    /** @nocollapse */ CardTransactionService.ngInjectableDef = defineInjectable({ factory: function CardTransactionService_Factory() { return new CardTransactionService(inject(HttpClient), inject(BASE_URL)); }, token: CardTransactionService, providedIn: "root" });
    return CardTransactionService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TransferFundsService = /** @class */ (function () {
    function TransferFundsService(http, baseUrl) {
        this.http = http;
        this.baseUrl = baseUrl;
    }
    /**
     * @param {?} supplierKey
     * @param {?} params
     * @return {?}
     */
    TransferFundsService.prototype.transferFunds = /**
     * @param {?} supplierKey
     * @param {?} params
     * @return {?}
     */
    function (supplierKey, params) {
        /** @type {?} */
        var headers = new HttpHeaders({
            'content-type': 'application/json'
        });
        return this.http.post(this.baseUrl + "/sup_widget/suppliers/" + supplierKey + "/payment/requests", params, { headers: headers });
    };
    /**
     * @param {?} availableBalance
     * @param {?} transferAmount
     * @return {?}
     */
    TransferFundsService.prototype.calcBalanceAfterTransferFunds = /**
     * @param {?} availableBalance
     * @param {?} transferAmount
     * @return {?}
     */
    function (availableBalance, transferAmount) {
        return availableBalance - transferAmount;
    };
    TransferFundsService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TransferFundsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: String, decorators: [{ type: Inject, args: [BASE_URL,] }] }
    ]; };
    /** @nocollapse */ TransferFundsService.ngInjectableDef = defineInjectable({ factory: function TransferFundsService_Factory() { return new TransferFundsService(inject(HttpClient), inject(BASE_URL)); }, token: TransferFundsService, providedIn: "root" });
    return TransferFundsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SuppliersService = /** @class */ (function () {
    function SuppliersService(http, baseUrl) {
        this.http = http;
        this.baseUrl = baseUrl;
    }
    /**
     * @return {?}
     */
    SuppliersService.prototype.getSupplierDetails = /**
     * @return {?}
     */
    function () {
        return this.http.get(this.baseUrl + "/sup_widget/suppliers", {}).pipe(map((/**
         * @param {?} data
         * @return {?}
         */
        function (data) { return data[0]; })));
    };
    /**
     * @param {?} supplierKey
     * @return {?}
     */
    SuppliersService.prototype.getSupplierStatus = /**
     * @param {?} supplierKey
     * @return {?}
     */
    function (supplierKey) {
        /** @type {?} */
        var supplierStatus = new Subject();
        this.http.get(this.baseUrl + "/sup_widget/suppliers/" + supplierKey + "/status", {})
            .subscribe((/**
         * @param {?} data
         * @return {?}
         */
        function (data) { return supplierStatus.next(data); }));
        return supplierStatus.asObservable();
    };
    /**
     * @param {?} supplierKey
     * @param {?=} mask
     * @return {?}
     */
    SuppliersService.prototype.getSupplierPaymentMethods = /**
     * @param {?} supplierKey
     * @param {?=} mask
     * @return {?}
     */
    function (supplierKey, mask) {
        if (mask === void 0) { mask = true; }
        /** @type {?} */
        var paymentMethods = new Subject();
        /** @type {?} */
        var params = new URLSearchParams();
        params.set('mask', mask.toString());
        this.http.get(this.baseUrl + "/sup_widget/suppliers/" + supplierKey + "/payment/configs?" + params, {})
            .subscribe((/**
         * @param {?} data
         * @return {?}
         */
        function (data) { return paymentMethods.next(data); }));
        return paymentMethods.asObservable();
    };
    SuppliersService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SuppliersService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: String, decorators: [{ type: Inject, args: [BASE_URL,] }] }
    ]; };
    /** @nocollapse */ SuppliersService.ngInjectableDef = defineInjectable({ factory: function SuppliersService_Factory() { return new SuppliersService(inject(HttpClient), inject(BASE_URL)); }, token: SuppliersService, providedIn: "root" });
    return SuppliersService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var CardTransactionsStatusEnum = {
    Held: 'Held',
    Cleared: 'Cleared',
    Declined: 'Declined',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PaymentMethodStatus = {
    Pending: 'pending',
    Approved: 'approved',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PaymentMethodType = {
    ACH: 'ACH',
    WIR: 'WIR',
    PPM: 'PPM',
    PCARD: 'PCARD',
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PybLibApiModule, BalanceService, CardTransactionService, TransferFundsService, SuppliersService, CardTransactionsStatusEnum, PaymentMethodStatus, PaymentMethodType, BASE_URL as ɵa };

//# sourceMappingURL=pyb-lib-api.js.map