import { PaymentMethodStatus } from '../enums/payment-method-status.enum';
import { PaymentMethodType } from '../enums/payment-method-type.enum';
export interface PcardShippingAddress {
    first_name: string;
    last_name: string;
    address1: string;
    city: string;
    state: string;
    zip: string;
    country: string;
}
export interface Pcard {
    cardNumber: string;
    cardCvc: string;
    cardExp: string;
    startDate: string;
    pcard_type_indicator: string;
    pcard_status: string;
    card_token: string;
    pcard_shipping_address: PcardShippingAddress;
    pcard_shipping_status: string;
}
export interface Address {
    addr1: string;
    addr2?: any;
    addr3?: any;
    city: string;
    state: string;
    postalCode: string;
    country: string;
}
export interface Beneficiary {
    beneficiaryName: string;
    address: Address;
    phoneNumber: string;
    accountNumber: string;
}
export interface Address2 {
    addr1?: any;
    addr2?: any;
    addr3?: any;
    city?: any;
    state?: any;
    postalCode?: any;
    country: string;
}
export interface Bank {
    Id: string;
    name?: any;
    branchId?: any;
    address: Address2;
}
export interface PaymentConfig {
    pcard?: Pcard;
    beneficiary?: Beneficiary;
    bank?: Bank;
}
export interface PaymentMethodDto {
    paymentConfigKey: string;
    paymentType: PaymentMethodType;
    isDefault: boolean;
    cashBackPct: number;
    createTS: number;
    paymentConfig: PaymentConfig;
    configStatus: PaymentMethodStatus;
}
